Index: firmware/doc/MitM_ATR/TEK00000.BMP
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: firmware/doc/MitM_ATR/TEK00000.BMP
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: firmware/doc/MitM_ATR/TEK00001.BMP
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: firmware/doc/MitM_ATR/TEK00001.BMP
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: firmware/src/simtrace/iso7816_uart.c
===================================================================
--- firmware/src/simtrace/iso7816_uart.c	(revision 67760)
+++ firmware/src/simtrace/iso7816_uart.c	(revision 67761)
@@ -99,6 +99,7 @@
 	u_int8_t atr_hist_len;
 	u_int8_t atr_last_td;
         u_int8_t atr_tx_gen;  //  Counts TA/B/C/D Generation
+        char atr_tck_xor;
 	struct iso_uart_atr_data atr;
 
 	u_int16_t prot_t_supported;
@@ -319,6 +320,7 @@
 		ih->atr_hist_len = 0;
 		ih->atr_last_td = 0;
 		ih->atr_tx_gen = 0;
+		ih->atr_tck_xor = 0;
 		ih->prot_t_supported = (1 << 0);
 		memset(&ih->atr, 0, sizeof(ih->atr));
 #ifndef SIMTRACE_MITM_ATR
@@ -493,6 +495,7 @@
 	        if (ih->atr_tx_gen == 3) {
 		    /* Need to suppress Class C indicator */
 		    static_atr.data[ih->atr.len] &= 0xF3;
+		    ih->atr_tck_xor ^= static_atr.data[ih->atr.len] ^ ih->atr.data[ih->atr.len];
 		}
 #endif
 	case ATR_S_WAIT_TB:
@@ -510,6 +513,7 @@
 		break;
 	case ATR_S_WAIT_TCK:
 		/* FIXME: process and verify the TCK */
+	        static_atr.data[ih->atr.len] ^= ih->atr_tck_xor;
 		ih->atr.len = new_len;
 		atr_done_wait_apdu(ih);
 		return ISO7816_S_WAIT_APDU;
